From: "Anna Vyalkova" <cyber+gentoo@sysrq.in>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/proj/guru:dev commit in: eclass/
Date: Mon, 1 Jan 2024 21:27:10 +0000 (UTC) [thread overview]
Message-ID: <1704144419.8281fc17d53355b09cf12e87a58bd31b29538f85.cybertailor@gentoo> (raw)
commit: 8281fc17d53355b09cf12e87a58bd31b29538f85
Author: Anna (cybertailor) Vyalkova <cyber+gentoo <AT> sysrq <DOT> in>
AuthorDate: Mon Jan 1 20:38:57 2024 +0000
Commit: Anna Vyalkova <cyber+gentoo <AT> sysrq <DOT> in>
CommitDate: Mon Jan 1 21:26:59 2024 +0000
URL: https://gitweb.gentoo.org/repo/proj/guru.git/commit/?id=8281fc17
rebar3.eclass: new eclass for dev-util/rebar:3
Signed-off-by: Anna (cybertailor) Vyalkova <cyber+gentoo <AT> sysrq.in>
eclass/rebar3.eclass | 295 +++++++++++++++++++++++++++++++++++++++++++++++++++
1 file changed, 295 insertions(+)
diff --git a/eclass/rebar3.eclass b/eclass/rebar3.eclass
new file mode 100644
index 0000000000..4104bdcf64
--- /dev/null
+++ b/eclass/rebar3.eclass
@@ -0,0 +1,295 @@
+# Copyright 1999-2023 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+# @ECLASS: rebar3.eclass
+# @MAINTAINER:
+# Anna (cybertailor) Vyalkova <cyber+gentoo@sysrq.in>
+# @AUTHOR:
+# Amadeusz Żołnowski <aidecoe@gentoo.org>
+# @SUPPORTED_EAPIS: 8
+# @BLURB: Build Erlang/OTP projects using dev-util/rebar:3.
+# @DESCRIPTION:
+# An eclass providing functions to build Erlang/OTP projects using
+# dev-util/rebar:3.
+#
+# rebar is a tool which tries to resolve dependencies itself which is by
+# cloning remote git repositories. Dependent projects are usually expected to
+# be in sub-directory 'deps' rather than looking at system Erlang lib
+# directory. Projects relying on rebar usually don't have 'install' make
+# targets. The eclass workarounds some of these problems. It handles
+# installation in a generic way for Erlang/OTP structured projects.
+
+case ${EAPI} in
+ 8) ;;
+ *) die "${ECLASS}: EAPI ${EAPI:-0} not supported" ;;
+esac
+
+if [[ -z ${_REBAR3_ECLASS} ]]; then
+
+inherit edo
+
+RDEPEND="dev-lang/erlang:="
+DEPEND="${RDEPEND}"
+BDEPEND="
+ dev-util/rebar:3
+ >=sys-apps/gawk-4.1
+"
+
+# @ECLASS_VARIABLE: REBAR_PROFILE
+# @DESCRIPTION:
+# Rebar profile to use.
+: "${REBAR_PROFILE:=default}"
+
+# @ECLASS_VARIABLE: REBAR_APP_SRC
+# @DESCRIPTION:
+# Relative path to .app.src description file.
+: "${REBAR_APP_SRC:=src/${PN}.app.src}"
+
+# @FUNCTION: get_erl_libs
+# @RETURN: the path to Erlang lib directory
+# @DESCRIPTION:
+# Get the full path without EPREFIX to Erlang lib directory.
+get_erl_libs() {
+ echo "/usr/$(get_libdir)/erlang/lib"
+}
+
+# @FUNCTION: _rebar_find_dep
+# @INTERNAL
+# @USAGE: <project_name>
+# @RETURN: 0 success, 1 dependency not found, 2 multiple versions found
+# @DESCRIPTION:
+# Find a Erlang package/project by name in Erlang lib directory. Project
+# directory is usually suffixed with version. It is matched to '<project_name>'
+# or '<project_name>-*'.
+_rebar_find_dep() {
+ local pn="${1}"
+ local p
+ local result
+
+ pushd "${EPREFIX}/$(get_erl_libs)" >/dev/null || return 1
+ for p in ${pn} ${pn}-*; do
+ if [[ -d ${p} ]]; then
+ # Ensure there's at most one matching.
+ [[ ${result} ]] && return 2
+ result="${p}"
+ fi
+ done
+ popd >/dev/null || die
+
+ [[ ${result} ]] || return 1
+ echo "${result}"
+}
+
+# @FUNCTION: rebar_disable_coverage
+# @USAGE: [<rebar_config>]
+# @DESCRIPTION:
+# Disable coverage in rebar.config. This is a workaround for failing coverage.
+# Coverage is not relevant in this context, so there's no harm to disable it,
+# although the issue should be fixed.
+rebar_disable_coverage() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ local rebar_config="${1:-rebar.config}"
+
+ sed -e 's/{cover_enabled, true}/{cover_enabled, false}/' \
+ -i "${rebar_config}" \
+ || die "failed to disable coverage in ${rebar_config}"
+}
+
+# @FUNCTION: erebar3
+# @USAGE: <targets>
+# @DESCRIPTION:
+# Run rebar with verbose flag. Die on failure.
+erebar3() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ (( $# > 0 )) || die "erebar: at least one target is required"
+
+ case ${1} in
+ eunit|ct)
+ local -x ERL_LIBS="." ;;
+ *)
+ local -x ERL_LIBS="${EPREFIX}/$(get_erl_libs)" ;;
+ esac
+
+ edo rebar3 "$@"
+}
+
+# @FUNCTION: rebar_fix_include_path
+# @USAGE: <project_name> [<rebar_config>]
+# @DESCRIPTION:
+# Fix path in rebar.config to 'include' directory of dependent project/package,
+# so it points to installation in system Erlang lib rather than relative 'deps'
+# directory.
+#
+# <rebar_config> is optional. Default is 'rebar.config'.
+#
+# The function dies on failure.
+rebar_fix_include_path() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ local pn="${1}"
+ local rebar_config="${2:-rebar.config}"
+ local erl_libs="${EPREFIX}/$(get_erl_libs)"
+ local p
+
+ p="$(_rebar_find_dep "${pn}")" \
+ || die "failed to unambiguously resolve dependency of '${pn}'"
+
+ gawk -i inplace \
+ -v erl_libs="${erl_libs}" -v pn="${pn}" -v p="${p}" '
+/^{[[:space:]]*erl_opts[[:space:]]*,/, /}[[:space:]]*\.$/ {
+ pattern = "\"(./)?deps/" pn "/include\"";
+ if (match($0, "{i,[[:space:]]*" pattern "[[:space:]]*}")) {
+ sub(pattern, "\"" erl_libs "/" p "/include\"");
+ }
+ print $0;
+ next;
+}
+1
+' "${rebar_config}" || die "failed to fix include paths in ${rebar_config} for '${pn}'"
+}
+
+# @FUNCTION: rebar_remove_deps
+# @USAGE: [<rebar_config>]
+# @DESCRIPTION:
+# Remove dependencies list from rebar.config and deceive build rules that any
+# dependencies are already fetched and built. Otherwise rebar tries to fetch
+# dependencies and compile them.
+#
+# <rebar_config> is optional. Default is 'rebar.config'.
+#
+# The function dies on failure.
+rebar_remove_deps() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ local rebar_config="${1:-rebar.config}"
+
+ mkdir -p "${S}/deps" && :>"${S}/deps/.got" && :>"${S}/deps/.built" || die
+ gawk -i inplace '
+/^{[[:space:]]*deps[[:space:]]*,/, /}[[:space:]]*\.$/ {
+ if ($0 ~ /}[[:space:]]*\.$/) {
+ print "{deps, []}.";
+ }
+ next;
+}
+1
+' "${rebar_config}" || die "failed to remove deps from ${rebar_config}"
+}
+
+# @FUNCTION: rebar_set_vsn
+# @USAGE: [<version>]
+# @DESCRIPTION:
+# Set version in project description file if it's not set.
+#
+# <version> is optional. Default is PV stripped from version suffix.
+#
+# The function dies on failure.
+rebar_set_vsn() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ local version="${1:-${PV%_*}}"
+
+ sed -e "s/vsn, git/vsn, \"${version}\"/" \
+ -i "${S}/${REBAR_APP_SRC}" \
+ || die "failed to set version in src/${PN}.app.src"
+}
+
+# @FUNCTION: rebar3_src_prepare
+# @DESCRIPTION:
+# Prevent rebar from fetching and compiling dependencies. Set version in
+# project description file if it's not set.
+#
+# Existence of rebar.config is optional, but file description file must exist
+# at 'src/${PN}.app.src'.
+rebar3_src_prepare() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ default_src_prepare
+ rebar_set_vsn
+ rm -f rebar.lock
+ if [[ -f rebar.config ]]; then
+ rebar_disable_coverage
+ rebar_remove_deps
+ fi
+}
+
+# @FUNCTION: rebar3_src_configure
+# @DESCRIPTION:
+# Configure with ERL_LIBS set.
+rebar3_src_configure() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ local -x ERL_LIBS="${EPREFIX}/$(get_erl_libs)"
+ default_src_configure
+}
+
+# @FUNCTION: rebar3_src_compile
+# @DESCRIPTION:
+# Compile project with rebar.
+rebar3_src_compile() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ erebar3 as "${REBAR_PROFILE}" release --all
+}
+
+# @FUNCTION: rebar3_src_test
+# @DESCRIPTION:
+# Run unit tests.
+rebar3_src_test() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ erebar3 eunit -v
+}
+
+# @FUNCTION: rebar3_install_lib
+# @USAGE: <dir>
+# @DESCRIPTION:
+# Install BEAM files, include headers and native libraries.
+#
+# Function expects that project conforms to Erlang/OTP structure.
+rebar3_install_lib() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ local dest="$(get_erl_libs)/${P}"
+ insinto "${dest}"
+
+ pushd "${1?}" >/dev/null || die
+ for dir in ebin include priv; do
+ if [[ -d ${dir} && ! -L ${dir} ]]; then
+ cp -pR ${dir} "${ED%/}/${dest}/" || die "failed to install ${dir}/"
+ fi
+ done
+ popd >/dev/null || die
+}
+
+# @FUNCTION: rebar3_src_install
+# @DESCRIPTION:
+# Install built release or library.
+#
+# Function expects that project conforms to Erlang/OTP structure.
+rebar3_src_install() {
+ debug-print-function ${FUNCNAME} "${@}"
+
+ pushd "_build/${REBAR_PROFILE}" >/dev/null || die
+ if [[ -d rel/${PN} ]]; then
+ if ! declare -f rebar3_install_release >/dev/null; then
+ die "${FUNCNAME}: a custom function named 'rebar3_install_release' is required to install a release"
+ fi
+ pushd rel/${PN} >/dev/null || die
+ rebar3_install_release || die
+ popd >/dev/null || die
+ elif [[ -d lib/${PN} ]]; then
+ rebar3_install_lib lib/${PN}
+ else
+ die "No releases or libraries to install"
+ fi
+ popd >/dev/null || die
+
+ einstalldocs
+}
+
+_REBAR3_ECLASS=1
+fi
+
+EXPORT_FUNCTIONS src_prepare src_compile src_test src_install
next reply other threads:[~2024-01-01 21:27 UTC|newest]
Thread overview: 179+ messages / expand[flat|nested] mbox.gz Atom feed top
2024-01-01 21:27 Anna Vyalkova [this message]
-- strict thread matches above, loose matches on Subject: below --
2024-11-28 10:44 [gentoo-commits] repo/proj/guru:dev commit in: eclass/ Anna Vyalkova
2024-11-26 14:15 Anna Vyalkova
2024-10-18 14:25 Anna Vyalkova
2024-07-14 17:47 Florian Schmaus
2024-07-14 7:27 Anna Vyalkova
2024-07-14 7:27 Anna Vyalkova
2024-07-14 7:27 Anna Vyalkova
2024-07-14 7:27 Anna Vyalkova
2024-07-14 7:27 Anna Vyalkova
2024-07-14 7:27 Anna Vyalkova
2024-07-14 7:27 Anna Vyalkova
2024-07-01 2:10 Anna Vyalkova
2024-04-27 9:50 Anna Vyalkova
2024-04-01 11:32 [gentoo-commits] repo/proj/guru:master " Julien Roy
2024-04-01 11:18 ` [gentoo-commits] repo/proj/guru:dev " Julien Roy
2024-03-31 17:57 [gentoo-commits] repo/proj/guru:master " Julien Roy
2024-03-31 17:49 ` [gentoo-commits] repo/proj/guru:dev " Julien Roy
2024-03-31 17:49 Julien Roy
2024-02-04 19:32 Anna Vyalkova
2024-02-04 19:32 Anna Vyalkova
2024-02-04 19:26 Anna Vyalkova
2024-02-04 19:26 Anna Vyalkova
2024-01-22 17:52 Anna Vyalkova
2024-01-22 10:54 Anna Vyalkova
2024-01-21 22:50 Anna Vyalkova
2024-01-20 7:12 Anna Vyalkova
2023-10-05 13:10 David Roman
2023-10-04 20:53 Anna Figueiredo Gomes
2023-08-30 5:30 Viorel Munteanu
2023-08-07 5:59 Haelwenn Monnier
2023-08-06 12:22 Haelwenn Monnier
2023-08-04 7:26 Florian Schmaus
2023-08-04 7:26 Florian Schmaus
2023-07-17 14:24 [gentoo-commits] repo/proj/guru:master " Florian Schmaus
2023-07-17 14:24 ` [gentoo-commits] repo/proj/guru:dev " Florian Schmaus
2023-06-24 19:22 Haelwenn Monnier
2023-05-21 16:27 Anna Vyalkova
2023-05-21 16:27 Anna Vyalkova
2023-05-09 19:30 Anna Vyalkova
2023-05-09 15:43 Anna Vyalkova
2023-05-09 15:43 Anna Vyalkova
2023-05-09 15:43 Anna Vyalkova
2023-05-09 15:43 Anna Vyalkova
2023-05-08 16:45 Anna Vyalkova
2023-05-06 18:00 Anna Vyalkova
2023-05-06 17:52 Anna Vyalkova
2023-05-06 15:55 Anna Vyalkova
2023-04-12 18:44 Jonas Frei
2023-04-06 14:09 Anna Vyalkova
2023-04-06 14:09 Anna Vyalkova
2023-03-31 18:48 Anna Vyalkova
2023-03-31 18:48 Anna Vyalkova
2023-03-31 18:14 Jonas Frei
2023-02-27 3:42 Anna Vyalkova
2023-02-27 3:42 Anna Vyalkova
2023-01-15 15:14 Anna Figueiredo Gomes
2023-01-08 2:17 Anna Vyalkova
2022-12-08 17:02 Anna Figueiredo Gomes
2022-11-26 13:51 Anna Vyalkova
2022-11-26 13:51 Anna Vyalkova
2022-11-26 13:51 Anna Vyalkova
2022-11-26 13:51 Anna Vyalkova
2022-11-25 17:54 Anna Vyalkova
2022-11-25 11:37 Anna Vyalkova
2022-11-25 11:37 Anna Vyalkova
2022-11-25 11:37 Anna Vyalkova
2022-11-25 11:37 Anna Vyalkova
2022-11-25 11:37 Anna Vyalkova
2022-11-25 11:37 Anna Vyalkova
2022-11-25 11:37 Anna Vyalkova
2022-11-25 11:37 Anna Vyalkova
2022-11-25 2:44 Anna Figueiredo Gomes
2022-11-25 2:38 Anna Figueiredo Gomes
2022-11-16 15:09 Anna Vyalkova
2022-11-16 14:30 Anna Vyalkova
2022-11-16 14:30 Anna Vyalkova
2022-11-10 0:50 Anna Figueiredo Gomes
2022-11-09 9:25 Anna Vyalkova
2022-11-08 19:20 Anna Vyalkova
2022-11-08 17:55 Anna Vyalkova
2022-11-08 17:55 Anna Vyalkova
2022-11-05 14:41 Anna Vyalkova
2022-07-20 9:33 Anna Vyalkova
2022-07-19 6:33 Anna Vyalkova
2022-07-19 6:07 Anna Vyalkova
2022-07-19 6:07 Anna Vyalkova
2022-07-16 21:08 Anna Vyalkova
2022-07-16 13:44 Anna Vyalkova
2022-07-16 13:44 Anna Vyalkova
2022-07-16 13:44 Anna Vyalkova
2022-07-16 13:44 Anna Vyalkova
2022-07-16 13:44 Anna Vyalkova
2022-07-16 13:44 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-13 2:31 Anna Vyalkova
2022-07-12 12:06 Robert Greener
2022-07-12 12:06 Robert Greener
2022-07-12 12:06 Robert Greener
2022-07-12 12:06 Robert Greener
2022-07-10 3:36 Anna Vyalkova
2022-07-05 20:09 Anna Vyalkova
2022-07-05 20:09 Anna Vyalkova
2022-07-05 20:09 Anna Vyalkova
2022-06-30 6:01 Anna Vyalkova
2022-06-30 6:01 Anna Vyalkova
2022-06-30 6:01 Anna Vyalkova
2022-06-29 11:52 Anna Vyalkova
2022-06-29 11:52 Anna Vyalkova
2022-06-26 2:36 Alessandro Barbieri
2022-06-25 19:42 Anna Vyalkova
2022-06-25 17:43 Anna Vyalkova
2022-06-25 17:43 Anna Vyalkova
2022-06-15 22:41 Alessandro Barbieri
2022-06-14 9:12 Alessandro Barbieri
2022-06-14 8:00 Alessandro Barbieri
2022-06-14 8:00 Alessandro Barbieri
2022-06-07 6:26 Anna Vyalkova
2022-06-02 1:23 Alessandro Barbieri
2022-06-02 1:23 Alessandro Barbieri
2022-05-31 13:14 Nicola Smaniotto
2022-05-28 21:19 Alessandro Barbieri
2022-05-11 11:29 Alessandro Barbieri
2022-05-08 1:58 Alessandro Barbieri
2022-05-07 7:25 Alessandro Barbieri
2022-05-07 2:11 Alessandro Barbieri
2022-05-07 2:11 Alessandro Barbieri
2022-05-07 2:11 Alessandro Barbieri
2022-05-07 0:48 Alessandro Barbieri
2022-05-07 0:48 Alessandro Barbieri
2022-05-06 16:34 Alessandro Barbieri
2022-05-05 7:32 Alessandro Barbieri
2022-05-05 7:32 Alessandro Barbieri
2022-05-05 7:32 Alessandro Barbieri
2022-04-24 16:46 Nicola Smaniotto
2022-04-19 18:31 Alessandro Barbieri
2022-04-16 16:20 Alessandro Barbieri
2022-04-15 20:34 Alessandro Barbieri
2022-04-15 20:34 Alessandro Barbieri
2022-04-14 9:26 Nicola Smaniotto
2022-04-11 9:41 Anna Vyalkova
2022-04-11 9:41 Anna Vyalkova
2022-04-11 9:41 Anna Vyalkova
2022-03-31 7:24 Anna Vyalkova
2022-02-17 21:11 Anna Vyalkova
2022-02-17 21:11 Anna Vyalkova
2021-10-05 21:24 Alessandro Barbieri
2021-09-29 13:14 Alessandro Barbieri
2021-09-29 13:08 Alessandro Barbieri
2021-09-08 10:46 Alessandro Barbieri
2021-07-25 18:15 Anna Vyalkova
2021-07-22 8:29 Anna Vyalkova
2021-07-22 8:29 Anna Vyalkova
2021-06-17 16:01 Alessandro Barbieri
2021-05-31 23:15 Alessandro Barbieri
2021-05-24 14:49 Alessandro Barbieri
2021-05-17 10:16 Alessandro Barbieri
2021-03-16 0:55 Alessandro Barbieri
2021-03-14 22:58 Alessandro Barbieri
2021-03-14 22:49 Alessandro Barbieri
2020-12-06 10:46 Andrew Ammerlaan
2020-05-06 23:36 Alessandro Barbieri
2020-05-06 23:36 Alessandro Barbieri
2020-05-01 11:45 Kurt Kanzenbach
2020-04-28 8:01 [gentoo-commits] repo/proj/guru:master " Andrew Ammerlaan
2020-04-28 8:00 ` [gentoo-commits] repo/proj/guru:dev " Andrew Ammerlaan
2020-04-28 7:44 [gentoo-commits] repo/proj/guru:master " Andrew Ammerlaan
2020-04-28 7:44 ` [gentoo-commits] repo/proj/guru:dev " Andrew Ammerlaan
2020-04-21 10:23 [gentoo-commits] repo/proj/guru:master " Andrew Ammerlaan
2020-04-21 10:22 ` [gentoo-commits] repo/proj/guru:dev " Andrew Ammerlaan
2020-04-21 10:20 [gentoo-commits] repo/proj/guru:master " Andrew Ammerlaan
2020-04-21 10:20 ` [gentoo-commits] repo/proj/guru:dev " Andrew Ammerlaan
2020-04-07 7:42 [gentoo-commits] repo/proj/guru:master " Andrew Ammerlaan
2020-04-06 19:36 ` [gentoo-commits] repo/proj/guru:dev " Andrew Ammerlaan
2020-04-07 7:42 [gentoo-commits] repo/proj/guru:master " Andrew Ammerlaan
2020-04-06 18:45 ` [gentoo-commits] repo/proj/guru:dev " Andrew Ammerlaan
2020-04-07 7:27 Andrew Ammerlaan
2020-04-07 7:16 Andrew Ammerlaan
2020-04-06 18:26 Andrew Ammerlaan
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1704144419.8281fc17d53355b09cf12e87a58bd31b29538f85.cybertailor@gentoo \
--to=cyber+gentoo@sysrq.in \
--cc=gentoo-commits@lists.gentoo.org \
--cc=gentoo-dev@lists.gentoo.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox